<script lang="ts">
import Vue from 'vue';
import {
  IsMobileMixin,
  UseLiteVimeo,
  UseLocalizedVideoSubtitles,
} from '~/mixins';

export default Vue.extend({
  name: 'BySolutionShowcase',
  mixins: [IsMobileMixin, UseLiteVimeo, UseLocalizedVideoSubtitles],
  props: {
    data: {
      type: Object,
      required: true,
      default: null,
    },
  },
  data() {
    return {
      pageProgress: 8,
      activeIndex: 0,
    };
  },
  mounted() {
    window.addEventListener('scroll', this.updatePageProgress);
  },
  destroyed() {
    window.removeEventListener('scroll', this.updatePageProgress);
  },
  methods: {
    getElementDistance(elem) {
      let location = 0;
      if (elem.offsetParent) {
        do {
          location += elem.offsetTop;

          elem = elem.offsetParent;
        } while (elem);
      }
      return location >= 0 ? location : 0;
    },
    updatePageProgress() {
      const elem = this.$refs.scroll_showcase.$el;
      const distanceFromTop = this.getElementDistance(elem);
      const elementHeight = elem.clientHeight;
      const currentPosition = window.pageYOffset;
      const bottomPosition = distanceFromTop + elementHeight;
      const threshold = 600;
      let activeIndex = 0;

      if (
        distanceFromTop < currentPosition &&
        currentPosition < bottomPosition
      ) {
        const percent =
          ((currentPosition - distanceFromTop) / elementHeight) * 100 + 15;
        if (percent > 100) {
          this.pageProgress = 100;
        } else {
          this.pageProgress = percent;
        }
        activeIndex = Math.ceil(
          (currentPosition - distanceFromTop) / threshold,
        );

        this.activeIndex = activeIndex;
      } else {
        this.activeIndex = 0;
      }
    },
  },
});
</script>

<template>
  <section>
    <SlpContainer>
      <SlpRow class="slp-mb-md-94 slp-mb-64">
        <SlpColumn :cols="1"></SlpColumn>
        <SlpColumn :cols="7">
          <SlpTypography class="slp-mb-16" tag="h2" variant="heading2-bold">
            {{ data.title }}
          </SlpTypography>
          <SlpTypography tag="p" variant="body1">
            {{ data.description }}
          </SlpTypography>
        </SlpColumn>
      </SlpRow>
    </SlpContainer>
    <SlpContainer ref="scroll_showcase" class="showcase">
      <SlpRow class="resources-block-container">
        <SlpColumn v-if="!isMobile" :cols="1">
          <div class="showcase__progress-container">
            <div
              class="showcase__progress-bar"
              :style="{ height: `${pageProgress}%` }"
            ></div>
          </div>
        </SlpColumn>
        <SlpColumn :cols="11">
          <SlpRow>
            <SlpColumn :cols="6">
              <div
                v-for="(item, index) in data.items"
                :key="item.title"
                class="showcase-item slp-pr-32 slp-pb-md-96 slp-pb-32"
                :class="{
                  'showcase-item--inactive': index !== activeIndex && !isMobile,
                }"
                :aria-disabled="index !== activeIndex && !isMobile"
              >
                <SlpIcon
                  v-if="item.icon && !item.icon.use_local_icon"
                  :name="item.icon.name"
                  class="slp-mb-24"
                  :variant="item.icon.variant"
                  :alt="item.icon.alt"
                  size="md"
                />
                <SlpTypography
                  v-if="item.long_title"
                  class="slp-mb-16"
                  tag="h3"
                  variant="heading4-bold"
                  >{{ item.title }}
                </SlpTypography>
                <SlpTypography
                  v-else
                  class="slp-mb-16"
                  tag="h3"
                  variant="heading3-bold"
                  >{{ item.title }}
                </SlpTypography>
                <SlpTypography class="slp-mb-24" tag="p" variant="body1"
                  >{{ item.text }}
                </SlpTypography>
                <ul class="slp-mb-16 showcase-item__list">
                  <li
                    v-for="(listItem, listIndex) in item.list"
                    :key="listIndex"
                    class="slp-mb-16"
                  >
                    <SlpIcon
                      name="check"
                      class="slp-mr-16"
                      variant="product"
                      alt="Check icon"
                    />
                    <SlpTypography tag="span" variant="body1"
                      >{{ listItem }}
                    </SlpTypography>
                  </li>
                </ul>
                <SlpButton
                  v-if="item.link"
                  class="slp-color-primary-200"
                  variant="ghost"
                  :href="item.link.href"
                  :data-ga-name="item.link.data_ga_name"
                  :data-ga-location="item.link.data_ga_location"
                  :aria-label="
                    item.link.data_ga_name || `${item.title} ${item.link.text}`
                  "
                >
                  <SlpTypography tag="span" variant="body1-bold">
                    {{ item.link.text }}
                  </SlpTypography>
                  <SlpIcon
                    name="chevron-lg-right"
                    class="slp-ml-8"
                    variant="product"
                  />
                </SlpButton>
                <div
                  v-if="isMobile"
                  class="showcase-item__media"
                  data-aos="fade"
                  data-aos-duration="500"
                >
                  <lite-vimeo
                    ref="video"
                    :videoid="getVimeoVideoId(createVideoSource(item.video))"
                    autoplay
                  ></lite-vimeo>
                </div>
              </div>
            </SlpColumn>
            <SlpColumn v-if="!isMobile" :cols="6" class="slp-mt-24">
              <div v-if="data.items[activeIndex]" class="showcase-item__media">
                <lite-vimeo
                  ref="video"
                  :videoid="
                    getVimeoVideoId(
                      createVideoSource(data.items[activeIndex].video),
                    )
                  "
                  autoplay
                ></lite-vimeo>
              </div>
            </SlpColumn>
          </SlpRow>
        </SlpColumn>
      </SlpRow>
    </SlpContainer>
  </section>
</template>

<style scoped lang="scss">
.showcase {
  &__progress-container {
    width: 2px;
    background: $color-surface-200;
    position: absolute;
    top: 0;
    bottom: 0;
    left: 0;
  }

  &__progress-bar {
    position: absolute;
    background: $color-surface-700;
    width: 2px;
  }

  &-item {
    position: relative;
    width: 100%;
    transition: all 0.3s ease-in-out;
    margin-bottom: $spacing-48;

    @media (min-width: $breakpoint-md) {
      margin-bottom: 0;
    }

    &__media {
      width: 100%;
      display: flex;
      align-items: center;
      position: sticky;
      top: 160px;

      @media (min-width: $breakpoint-md) {
        height: 368px;
        &:before {
          content: '';
          background: $color-surface-800;
          position: absolute;
          top: 0;
          width: 50vw;
          height: 100%;
          transform: translateX(5%);
        }
      }

      lite-vimeo {
        z-index: 1;
        width: 100%;
        max-width: 498px;
        height: 279px;
        max-height: 279px;
      }
    }

    &__list {
      li {
        display: flex;
        align-items: baseline;
      }
    }

    &--inactive {
      opacity: 0.3;
    }
  }
}
</style>
